
#include "def.h"

#define LINE_BUF_SIZE 23   //Maximum input string length
#define ARG_BUF_SIZE 16     //Maximum argument string length
#define MAX_NUM_ARGS 3      //Maximum number of arguments

int LEDpin = 13;
int blink_cycles = 10;      //How many times the LED will blink
bool error_flag = false;


char line[LINE_BUF_SIZE];
char args[MAX_NUM_ARGS][ARG_BUF_SIZE];

//Function declarations
int cmd_help();
int cmd_led();
int cmd_trx();
int cmd_exit();

//List of functions pointers corresponding to each command
int (*commands_func[])(){
    &cmd_help,
    &cmd_trx,
    &cmd_exit
};

//List of command names
const char *commands_str[] = {
    "help",
    "trx",
    "exit"
};

//List of LED sub command names
const char *led_args[] = {
    "on",
    "off",
    "blink"
};

int num_commands = sizeof(commands_str) / sizeof(char *);

extern char trxName[8][16];
extern int statusButtons;

void read_line(void);
void parse_line (void);
int execute(void);
void help_help(void);
void help_trx(void);
void help_exit(void);

