/*
 * def.h
 *
 *  Created on: Apr 25, 2022
 *      Author: Hans
 */

#ifndef DEF_H_
#define DEF_H_

#include <Arduino.h>
#include <eeprom.h>
#include <SPI.h>
#include <stdio.h>


//#define MIC_1_MIN_GAIN 9
#define MIC_1_MIN_GAIN 30
#define MIC_2_MIN_GAIN 30

// Software SPI
	#define PIN_CLK A3		//Serial Clock
	#define PIN_SDA A4		//Serial Data
	#define PIN_SCL	A2		//Set Output
	#define PIN_RCK	A1		//Reset Output
	#define PIN_OE  A0		//Output Enable

// Buttons
	#define ADC_FILTER		1
	#define PIN_UD 			A7
	#define BTN_1_PRESSED      1
	#define BTN_2_PRESSED      2
	#define BTN_3_PRESSED      4
	#define BTN_4_PRESSED      8
	#define BTN_ENC_PRESSED    16
	#define BTN_UP_PRESSED	   32
	#define BTN_DOWN_PRESSED   64

//EEPROM

#define EEPROM_TRX_LEVEL 	0	//output level (8 bytes)
#define EEPROM_MIC1  		12
#define EEPROM_MIC2  		13
#define EEPROM_UD_MODE 		14  //Up Donwn button mode
#define EEPROM_ACT_TRX_1 	15
#define EEPROM_ACT_TRX_2 	16
#define EEPROM_TRX_NAME 	20	//8 * 15 byte = 120 byte

#define AUDIOMAX 255

//static unsigned char trxAttSetp[]  = {255,248,241,234,226,217,208,198,187,175,162,150,135,122,107,94,81,68,58,49,41,35,29,25,22,19,16,14,12,11,9,8,7,6,5,5,4,4,3,3,3,2,2,2,2,1,0};
static unsigned char trxAttSetp[]  = {0,1,2,2,2,2,3,3,3,4,4,5,5,6,7,8,9,11,12,14,16,19,22,25,29,35,41,49,58,58,81,94,107,122,135,150,162,175,187,198,208,217,226,234,241,248,255};
static unsigned char micGainSetp[] = {0,115,198,220,232,239,243,245,248,249,250,251,252,253,254,255};
static unsigned char micGainSteps[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,14,16,20};




#endif /* DEF_H_ */
