/*
 * extIO.cpp
 *
 *  Created on: Apr 25, 2022
 *      Author: Hans
 */

//Copyright 2022 Hans Moeller. Licenced under the GNU GPL Version 3.
//
//
// This Dummy Load controller project is distributed,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

#include"extIO.h"


/*###################################################################################
74HC595:
SCL-10(/MR) : Master Reset setzt SRs auf 0, wenn gleichzeitig STCP (steigende Flanke) dann auch die Ausgnge auf 0
SCK-11(SHCP): SR Clock ldt neuen Wert mit steigender Flanke ins SR
RCK-12(STCP): Storage Reg Clock steigende Flanke ldt SR in die Ausgnge
G-13(/OE)   : Output Enable muss immer 0 sein
#####################################################################################*/
void SetShiftReg(unsigned int val)
{
int i;

 //   if(val == 0)
 //   {


    	// setze alle Ausgnge auf 0
//        digitalWrite(PIN_SCL,LOW);    // ziehe Reset
//        digitalWrite(PIN_RCK,HIGH);   // auf die Ausgnge
 //       digitalWrite(PIN_SCL,HIGH);   // und zurck in die Grundstellung
//        digitalWrite(PIN_RCK,LOW);
//        return;
//    }

    for(i=(16-1); i>=0; i--)
    {
        if(val & (1L << i))
        	digitalWrite(PIN_SDA,HIGH);
        else
        	digitalWrite(PIN_SDA,LOW);

        digitalWrite(PIN_CLK,HIGH);    // Takt
        digitalWrite(PIN_CLK,LOW);
    }

    digitalWrite(PIN_RCK,HIGH);    // auf die Ausgnge
    digitalWrite(PIN_RCK,LOW);



}

/*****************************************************************/
/* Set external IO												 */
/*****************************************************************/
void SetExtIO(char channel, char action)
{

	unsigned int sr;

	sr = 0;
	sr = (1<<channel);		//Shift to output bit

    if (action >= 1){
    	SetShiftReg(oldStatus | sr);	//Set output HIGH
    	oldStatus = oldStatus | sr;		//Save status

    }

    else {
    	SetShiftReg(oldStatus & ~sr);		//Set output LOW
    	oldStatus = (oldStatus & ~sr);	//Save status

    }

}

/*****************************************************************/
/* Initialize external outputs									 */
/*****************************************************************/
void InitExtIO(void){

	SetShiftReg(7);		//Set the first 3 outputs high to disable the digital potentiometers
	oldStatus = 7;		//Update staus

	digitalWrite(PIN_OE, LOW);		//OE has to be low to disable Tri-State
}

