/*
 * menu.cpp
 *
 *  Created on: Apr 25, 2022
 *      Author: Hans
 */
//Copyright 2022 Hans Moeller. Licenced under the GNU GPL Version 3.
//
//
// This Dummy Load controller project is distributed,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
#include "menu.h"

/*****************************************************************/
/* Modify microphone input level								 */
/*****************************************************************/
void ModifyMicLevel(int _mic){

	char buffer[20];
//	int setPoint ;
	unsigned char gain=0;
/*	static bool levelX10;

	if (statusButtons == BTN_1_PRESSED){
		if (levelX10 == false){
			levelX10 = true;
			encoderCounter = micGain[_mic] / 10;
		}
		else{
			levelX10 = false;
			encoderCounter = micGain[_mic] ;
		}
		statusButtons = 0;
	}
*/
	if (statusButtons == BTN_3_PRESSED){
		EEPROM.write(EEPROM_MIC1 + _mic , micGain[_mic] );
		menuMode = MENU_SETUP;
		statusButtons = 0;
		Lcd.noBlink();
		updateLCD = true;
	}

	if (statusButtons == BTN_4_PRESSED){
		menuMode = MENU_SETUP;
		statusButtons = 0;
		Lcd.noBlink();
		updateLCD = true;
	}

//	if (levelX10) micGain[_mic] = (EncModifyInt(0,25) * 10);
//	else micGain[_mic] = EncModifyInt(0,255);
	micGain[_mic] = EncModifyInt(0,15);


	if (_mic == 0) gain = micGainSteps[micGain[_mic]] + MIC_1_MIN_GAIN;
	else gain = micGainSteps[micGain[_mic]] + MIC_2_MIN_GAIN;

	Lcd.setCursor(0, 0);
	sprintf(buffer,"Mic#%d: Level  %2udB",(_mic+1),gain);
	Lcd.print(buffer);
	Lcd.setCursor(0, 1);
//	if (levelX10)	Lcd.print("x1        SAVE  EXIT");
//	else Lcd.print("x10       SAVE  EXIT");
	Lcd.print("          SAVE  EXIT");
	Lcd.setCursor(15,0);
	Lcd.blink();
	digitalPotWrite(_mic,micGain[_mic]);

}


/*****************************************************************/
/* Modify TRX output level										 */
/*****************************************************************/
void ModifyTrxLevel(int _trx){

	char buffer[20];
/*	static bool levelX10;

	if (statusButtons == BTN_1_PRESSED){
		if (levelX10 == false){
			levelX10 = true;
			encoderCounter = audioLevel[_trx] / 10;
		}
		else{
			levelX10 = false;
			encoderCounter = audioLevel[_trx] ;
		}
		statusButtons = 0;
	}
*/
	if (statusButtons == BTN_3_PRESSED){
		statusButtons = 0;
		EEPROM.write(EEPROM_TRX_LEVEL + _trx , audioLevel[_trx] );
		menuMode = MENU_SETUP_INI_TRX;
		Lcd.noBlink();
		updateLCD = true;
	}

	if (statusButtons == BTN_4_PRESSED){
		statusButtons = 0;
		menuMode = MENU_SETUP_INI_TRX;
		Lcd.noBlink();
		updateLCD = true;
	}

//	if (levelX10) audioLevel[_trx] = (EncModifyChar(0,25) * 10);
//	else audioLevel[_trx] = EncModifyChar(0,255);
	audioLevel[_trx] = EncModifyChar(0,46);

	digitalPotWrite(2,audioLevel[_trx]);

	Lcd.setCursor(0, 0);
	sprintf(buffer,"TRX %d: Level  %2udB",(_trx +1),audioLevel[_trx]);
	Lcd.print(buffer);
	Lcd.setCursor(0, 1);
//	if (levelX10)	Lcd.print("x1        SAVE  EXIT");
//	else Lcd.print("x10       SAVE  EXIT");
	Lcd.print("          SAVE  EXIT");
	Lcd.setCursor(15,0);
	Lcd.blink();

}
/*****************************************************************/
/* Menu und Funktionssteuerung									 */
/*****************************************************************/
void MenuControl (void){

	char buffer[20];

	static unsigned char item;

// --- Normal Main Menu ---
	if (menuMode == MENU_DEFAULT){

		if (statusButtons == BTN_ENC_PRESSED && selMic == false){		//Select microphone 2
				selMic = true;
				encoderCounter = activeTrx2;							//initialize encoder with current TRX selection for this microphone
				statusButtons = 0;
				timer_Btn = 10;											//Button timeout
		}

		else if (statusButtons == BTN_ENC_PRESSED && selMic == true){	//Select microphone 1
				selMic = false;
				encoderCounter = activeTrx1;
				statusButtons = 0;
				timer_Btn = 10;
		}

		//External Up & Down button
		if( upDownMode == 0 && statusButtons == BTN_UP_PRESSED ){
			if (activeTrx1 < 7 && lastPtt == false ) {
				activeTrx1++;
				encoderCounter = activeTrx1 ;
				selMic = false;
			}
			else if (activeTrx2 < 7 && lastPtt == true ) {
				activeTrx2++;
				encoderCounter = activeTrx2 ;
				selMic = true;
			}

			statusButtons = 0;
			timer_Btn = 10;
		}

		else if( upDownMode == 0 && statusButtons == BTN_DOWN_PRESSED ){
			if (activeTrx1 > 0 && lastPtt == false ) {
				activeTrx1--;
				encoderCounter = activeTrx1 ;
				selMic = false;
			}
			else if (activeTrx2 > 0 && lastPtt == true ) {
				activeTrx2--;
				encoderCounter = activeTrx2 ;
				selMic = true;
			}

			statusButtons = 0;
			timer_Btn = 10;
		}

		else if( upDownMode == 1 && statusButtons == BTN_UP_PRESSED && (activeTrx1 < 7)){
			activeTrx1++;
			encoderCounter = activeTrx1 ;
			selMic = false;
			statusButtons = 0;
			timer_Btn = 10;
		}

		else if( upDownMode == 1 && statusButtons == BTN_DOWN_PRESSED && (activeTrx1 > 0)){
			activeTrx1--;
			encoderCounter = activeTrx1 ;
			selMic = false;
			statusButtons = 0;
			timer_Btn = 10;
		}

		else if( upDownMode == 2 && statusButtons == BTN_UP_PRESSED && (activeTrx2 < 7)){
			activeTrx2++;
			encoderCounter = activeTrx2 ;
			selMic = true;
			statusButtons = 0;
			timer_Btn = 10;
		}

		else if( upDownMode == 2 && statusButtons == BTN_DOWN_PRESSED && (activeTrx2 > 0)){
			activeTrx2--;
			encoderCounter = activeTrx2 ;
			selMic = true;
			statusButtons = 0;
			timer_Btn = 10;
		}

		if (selMic == false) activeTrx1 = EncModifyChar(0,7);			//modify active TRX for the selected microphone
		else activeTrx2 = EncModifyChar(0,7);


		if (statusButtons != 0 && statusButtons != BTN_ENC_PRESSED && statusButtons != BTN_UP_PRESSED && statusButtons != BTN_DOWN_PRESSED) {	//Got to SETUP if any other button is pressed
			menuMode = MENU_INI_MODE;
			statusButtons = 0;
		}


		//Display selections
		Lcd.clear();
		Lcd.setCursor(0, 0);
		sprintf(buffer,"Mic1 %s" ,trxName[activeTrx1]);
		Lcd.print(buffer);

		Lcd.setCursor(0, 1);
		sprintf(buffer,"Mic2 %s" ,trxName[activeTrx2]);
		Lcd.print(buffer);

		Lcd.blink();
		if (selMic == false) Lcd.setCursor(0,0);
		else Lcd.setCursor(0,1);

		statusButtons = 0;
	} // DEFAULT MENU


	// --- Mode Selelection ---
	if (menuMode == MENU_INI_MODE){
		Lcd.noCursor();
		Lcd.noBlink();
		encoderCounter = 0;

		Lcd.clear();
		Lcd.setCursor(0, 0);
		Lcd.print("Mode:");
		Lcd.setCursor(0, 1);
		Lcd.print("VOX       SETUP EXIT");
		menuMode =  MENU_MODE;
	}


	if (menuMode == MENU_MODE){

		if (statusButtons == BTN_1_PRESSED)  menuMode = MENU_INI_VOX;
		if (statusButtons == BTN_3_PRESSED)  menuMode = MENU_INI_SETUP;
		if (statusButtons == BTN_4_PRESSED)  menuMode = MENU_SETUP_EXIT;
		statusButtons = 0;
	}


	// --- VOX mode ---
	if (menuMode == MENU_INI_VOX){
		Lcd.noCursor();
		Lcd.noBlink();
		encoderCounter = 0;
		Lcd.clear();
		voxMode=1;
		encoderCounter = 1;
		menuMode = MENU_VOX;
	}

	if (menuMode == MENU_VOX){

		voxMode = EncModifyChar(0,4);
		Lcd.clear();
		Lcd.setCursor(0, 0);
		Lcd.print("VOX-Mode:");
		Lcd.setCursor(0, 1);
		strcpy_P(buffer, (char *)pgm_read_word(&(VOX_LIST[voxMode])));		//Display selected setup item
		Lcd.print(buffer);

		if ((statusButtons == BTN_ENC_PRESSED || statusButtons == BTN_1_PRESSED) && voxMode == 0)	menuMode = MENU_SETUP_EXIT;
		statusButtons = 0;

	}


// --- Setup Menu ---
	if (menuMode == MENU_INI_SETUP){
		Lcd.noCursor();
		Lcd.noBlink();
		encoderCounter = 0;
		menuMode = MENU_SETUP;
	}


	if (menuMode == MENU_SETUP){

		item = EncModifyChar(0,MENU_SETUP_MAX-1);
		Lcd.clear();
		Lcd.setCursor(0, 0);
		Lcd.print("SETUP:");
		Lcd.setCursor(0, 1);
		strcpy_P(buffer, (char *)pgm_read_word(&(TEXT_SETUP_LIST[item])));		//Display selected setup item
		Lcd.print(buffer);

		if (statusButtons == BTN_ENC_PRESSED)	menuMode = MENU_SETUP_INI_MIC1 + item;		//Go to modify the selected setup item
		else if(statusButtons == BTN_1_PRESSED && (MENU_SETUP_INI_MIC1 + item) == MENU_SETUP_EXIT) menuMode = MENU_SETUP_EXIT;	//Exit also witth buttom #1 if exit is selected
		statusButtons = 0;

	}

// --- Microphone level ---
	if (menuMode == MENU_SETUP_INI_MIC1){
		encoderCounter = micGain[0];
		menuMode = MENU_SETUP_MIC1;
	}

	if (menuMode == MENU_SETUP_MIC1){
		ModifyMicLevel(0);
		}


	if (menuMode == MENU_SETUP_INI_MIC2){
		encoderCounter = micGain[1];
		menuMode = MENU_SETUP_MIC2;
	}

	if (menuMode == MENU_SETUP_MIC2){
		ModifyMicLevel(1);
	}

// ---  TRX audio output level setup  ---
	if (menuMode == MENU_SETUP_INI_TRX){
			encoderCounter = 0;
			menuMode = MENU_SETUP_TRX;
		}


	if (menuMode == MENU_SETUP_TRX){

		if (statusButtons == BTN_4_PRESSED){
			menuMode = MENU_SETUP;
			encoderCounter = MENU_SETUP_INI_TRX;
			statusButtons = 0;
			updateLCD = true;
		}

		if (statusButtons == BTN_ENC_PRESSED){
			statusButtons = 0;
			menuMode = MENU_SETUP_INI_TRXMOD;
		}

		item = EncModifyChar(0,7);

		Lcd.clear();
		Lcd.setCursor(0, 0);
		sprintf(buffer,"TRX %1d: Level  %2udB" ,item + 1,audioLevel[item]);
		Lcd.print(buffer);
		Lcd.setCursor(0, 1);
		Lcd.print("                EXIT");
	}


	if (menuMode == MENU_SETUP_INI_TRXMOD){
		encoderCounter = audioLevel[item];
		menuMode = MENU_SETUP_TRXMOD;
	}

	if (menuMode == MENU_SETUP_TRXMOD){
		ModifyTrxLevel(item);

	}

	if (menuMode == MENU_SETUP_INI_NAME){
		//Lcd.clear();
		Lcd.setCursor(0, 1);
		Lcd.print("CLI mode active     ");

		cli_init();
		menuMode = MENU_SETUP_NAME;
	}

	if (menuMode == MENU_SETUP_NAME){
		while(statusButtons == 0)run_cli();
		statusButtons = 0;
		Serial.end();
		menuMode = MENU_SETUP_EXIT;


	}


// --- Up / DOWN button assignment ---
	if (menuMode == MENU_SETUP_INI_UPDWN){
		encoderCounter = upDownMode;
		menuMode = MENU_SETUP_UPDWN;
	}

	if (menuMode == MENU_SETUP_UPDWN){
		upDownMode = EncModifyChar(0,2);

		if (upDownMode == 0) {
			Lcd.setCursor(0, 1);
			Lcd.print("Auto ");
		}

		else {
			Lcd.setCursor(0, 1);
			sprintf(buffer,"MIC %1d               " ,upDownMode);
			Lcd.print(buffer);
		}

		if (statusButtons == BTN_ENC_PRESSED){
			EEPROM.write(EEPROM_UD_MODE,upDownMode);
			statusButtons = 0;
			menuMode = MENU_SETUP_EXIT;
		}
	}


// ---  Menu Exit ---
	if (menuMode == MENU_SETUP_EXIT){						//Exit Setup menu
		Lcd.clear();
		if (selMic == false) encoderCounter = activeTrx1;	//restore encoder setting
		else encoderCounter = activeTrx1;
		menuMode = MENU_DEFAULT;							//Go to default menu
		updateLCD = true;

	}




	statusButtons = 0;
}



