/*
 * menu.h
 *
 *  Created on: Apr 25, 2022
 *      Author: Hans
 */

#ifndef MENU_H_
#define MENU_H_

#include "def.h"
#include <LiquidCrystal.h>
extern LiquidCrystal Lcd;
extern bool updateLCD;


//Menu Definition
#define MENU_DEFAULT 		0
#define MENU_INI_MODE		1
#define MENU_MODE	 		2
#define MENU_INI_VOX 		3
#define MENU_VOX	 		4

#define MENU_INI_SETUP	  		10
#define MENU_SETUP	  			11
#define MENU_SETUP_INI_MIC1 	20
#define MENU_SETUP_INI_MIC2		21
#define MENU_SETUP_INI_TRX		22
#define MENU_SETUP_INI_NAME		23
#define MENU_SETUP_INI_UPDWN	24
#define MENU_SETUP_EXIT 		25

#define MENU_SETUP_MIC1    		30
#define MENU_SETUP_MIC2			31
#define MENU_SETUP_TRX			40
#define MENU_SETUP_INI_TRXMOD	41
#define MENU_SETUP_TRXMOD		42
#define MENU_SETUP_NAME			43
#define MENU_SETUP_UPDWN		44

//Fixed strings
#define MENU_SETUP_MAX	6
static const char setup_1[]PROGMEM = "Mic 1 Gain";
static const char setup_2[]PROGMEM = "Mic 2 Gain";
static const char setup_3[]PROGMEM = "TRX Gain";
static const char setup_4[]PROGMEM = "TRX Names";
static const char setup_5[]PROGMEM = "Up/Dwn assignment";
static const char setup_6[]PROGMEM = "Exit";
static const char* const TEXT_SETUP_LIST[] PROGMEM = {setup_1,setup_2,setup_3,setup_4,setup_5,setup_6};


static const char vox_1[]PROGMEM = "CANCEL";
static const char vox_2[]PROGMEM = "TRX1 - Mic1";
static const char vox_3[]PROGMEM = "TRX1 - Mic2";
static const char vox_4[]PROGMEM = "TRX2 - Mic1";
static const char vox_5[]PROGMEM = "TRX2 - Mic2";
static const char* const VOX_LIST[] PROGMEM = {vox_1,vox_2,vox_3,vox_4,vox_5};

unsigned char menuMode;
bool Adjust = false;
bool LevelX10 = false;

extern unsigned char audioLevel[8];

extern int statusButtons;
extern volatile int encoderCounter;
extern char trxName[8][16];
extern int micGain[2];
extern unsigned char activeTrx1;
extern unsigned char activeTrx2;
extern unsigned char voxMode;
extern unsigned char upDownMode;
extern unsigned char lastPtt;
extern bool selMic;

extern 	unsigned char
timer_Btn, // BTNnentprellung
timer_Btn_1,
timer_Btn_2,
timer_Btn_3,
timer_Btn_4,
timer_Btn_long,
timer_Lcd;


extern void digitalPotWrite(int,int);
unsigned char EncModifyChar(unsigned char,unsigned char);
int EncModifyInt(int, int);
extern cli_init(void);
extern run_cli(void);

void MenuControl (void);

#endif /* MENU_H_ */
