/*
 * trx_mic_ctl.h
 *
 *  Created on: Apr 25, 2022
 *      Author: Hans
 */

#ifndef TRX_MIC_CTL_H_
#define TRX_MIC_CTL_H_


#include "def.h"
#include "rotary.h"
#include <LiquidCrystal.h>

//LCD definition
	LiquidCrystal Lcd(7, 8, 9, 10, 11, 12);
//	char LCDmsg[16];
	boolean updateLCD = false;

//Rotary Encoder
//Encoder is wired with the common to ground and the two outputs to pins 2 and 3.
	Rotary rotary = Rotary(2, 3);
	volatile int encoderCounter;


//Pin definitions
	const byte MIC_SEL  = 3;
	const byte PTT_LED1 = 4;
	const byte PTT_LED2 = 5;
	const byte PTT1_IN = A5;
	const byte PTT2_IN = A6;

	const byte BTN_S1 = 6;
	const byte BTN_S2 = 1;
	const byte BTN_R1 = 5;
	const byte BTN_R2 = 13;
	const byte BTN_ENC = 4;		//Button on rotary encoder

	byte cmd_byte = 0x00; //command byte to write MCP41xx output


	// Softwaretimer:
	unsigned char
		  timer_Btn, // BTNnentprellung
	      timer_Lcd;

	unsigned int  timer_AutoSave;

	int statusButtons;
	unsigned char audioLevel[8];
	int micGain[2];
	unsigned char upDownMode;
	unsigned char lastPtt;
	bool selMic;

	char buffer[20];



	unsigned char activeTrx1;
	unsigned char activeTrx2;
	unsigned char voxMode;
	extern unsigned char menuMode;

	char trxName[8][16];

	extern void SetExtIO(char,char);
	extern MenuControl(void);
	extern InitExtIO(void);


	void rotate(void);
	void digitalPotWrite(int ,int);

#endif /* TRX_MIC_CTL_H_ */
